searchNodes=[{"doc":"","ref":"Mix.Tasks.Compile.Asn.html","title":"Mix.Tasks.Compile.Asn","type":"task"},{"doc":"Functions for FIDO2 registration and authenticationOptionsThe options are set when generating the challenge (for both registration and authentication). Options can be configured either globally in the configuration file or when generating the challenge. Some also have default values.Option values set during challenge generation take precedence over globally configured options, which takes precedence over default values.These options are:OptionTypeApplies toDefault valueNotesattestation&quot;none&quot; or &quot;direct&quot;&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;&quot;none&quot;originString.t()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;Mandatory. Example: https://www.example.comrp_idString.t() or :auto&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;If set to :auto, automatically determined from the origin (set to the host)With :auto, it defaults to the full host (e.g.: www.example.com). This option allow you to set the rp_id to another valid value (e.g.: example.com)user_verification&quot;discouraged&quot;, &quot;preferred&quot; or &quot;required&quot;&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;&quot;preferred&quot;trusted_attestation_types[Wax.Attestation.type()]&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;[:none, :basic, :uncertain, :attca, :self]verify_trust_rootboolean()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;trueOnly for u2f and packed attestation. tpm attestation format is always checked against metadataacceptable_authenticator_statuses[Wax.Metadata.TOCEntry.StatusReport.status()]&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;[:fido_certified, :fido_certified_l1, :fido_certified_l1plus, :fido_certified_l2, :fido_certified_l2plus, :fido_certified_l3, :fido_certified_l3plus]The :update_available status is not whitelisted by defaulttimeoutnon_neg_integer()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;20 * 60The validity duration of a challengeandroid_key_allow_software_enforcementboolean()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;falseWhen registration is a Android key, determines whether software enforcement is acceptable (true) or only hardware enforcement is (false)silent_authentication_enabledboolean()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;falseSee https://github.com/fido-alliance/conformance-tools-issues/issues/434FIDO2 Metadata service (MDS) configurationThe FIDO Alliance provides with a list of metadata statements of certified FIDO2 authenticators. A metadata statement contains trust anchors (root certificates) to verify attestations. Wax can automatically keep this metadata up to date but needs a access token which is provided by the FIDO Alliance. One can request it here: https://mds2.fidoalliance.org/tokens/.Once the token has been granted, it has to be added in the configuration file (consider adding it to your *.secret.exs files) with the :metadata_access_token key. The update frquency can be configured with the :metadata_update_interval key (in seconds, defaults to 12 hours). Example:config/dev.exs:use Mix.Config config :wax_, metadata_update_interval: 3600,config/dev.secret.exs:use Mix.Config config :wax_, metadata_access_token: &quot;d4904acd10a36f62d7a7d33e4c9a86628a2b0eea0c3b1a6c&quot;Note that some FIDO1 certififed authenticators, such as Yubikeys, won't be present in this list and Wax doesn't load data from the former (&quot;FIDO1&quot;) metadata Web Service. The FIDO Alliance plans to provides with a web service having both FIDO1 and FIDO2, but there is no roadmap as of September 2019.During the registration process, when trust root is verified against FIDO2 metadata, only metadata entries whose last status is whitelisted by the :acceptable_authenticator_statuses will be used. Otherwise a warning is logged and the registration process fails. Metadata is still loaded for debugging purpose in the :wax_metadata ETS table.Loading FIDO2 metadata from a directoryIn addition to the FIDO2 metadata service, it is possible to load metadata from a directory. To do so, the :metadata_dir application environment variable must be set to one of:a String.t(): the path to the directory containing the metadata filesan atom(): in this case, the files are loaded from the &quot;fido2_metadata&quot; directory of the private (&quot;priv/&quot;) directory of the application (whose name is the atom)In both case, Wax tries to load all files (even directories and other special files).Example configurationconfig :wax_, origin: &quot;http://localhost:4000&quot;, rp_id: :auto, metadata_dir: :my_applicationwill try to load all files of the &quot;priv/fido2_metadata/&quot; if the :my_application as FIDO2 metadata statements. On failure, a warning is emitted.","ref":"Wax.html","title":"Wax","type":"module"},{"doc":"Verifies a authentication response from the client WebAuthn javascript callThe input params are:credential_id: the credential id returned by the WebAuthn javascript API. Must be of the same form as the one passed to new_authentication_challenge/2 as it will be compared against the previously retrieved valid credential idsauth_data_bin: the authenticator data returned by the WebAuthn javascript API. Must be the raw binary, not the base64 encoded formsig: the signature returned by the WebAuthn javascript API. Must be the raw binary, not the base64 encoded formclient_data_json_raw: the JSON string (and not the decoded JSON) of the client data JSON as returned by the WebAuthn javascript APIchallenge: the challenge that was generated beforehand, and whose bytes has been sent to the browser and used as an input by the WebAuthn javascript APIThe call returns {:ok, authenticator_data} in case of success, or {:error, :reason} otherwise.The auth_data.sign_count is the number of signature performed by this authenticator for this credential id, and can be used to detect cloning of authenticator. See point 17 of the 7.2. Verifying an Authentication Assertion for more details.","ref":"Wax.html#authenticate/5","title":"Wax.authenticate/5","type":"function"},{"doc":"Generates a new challenge for authenticationThe first argument is a list of (credential id, cose key) which were previsouly registered (after successful register/3) for a user. This can be retrieved from a user database for instance.The returned structure:Contains the challenge bytes under the bytes key (e.g.: challenge.bytes). This is a random value that must be used by the javascript WebAuthn callMust be passed backed to authenticate/5Typically, this structure is stored in the session (cookie...) for the time the WebAuthn authentication process is performed on the client side.Example:iex&gt; cred_ids_and_associated_keys = UserDatabase.load_cred_id(&quot;Georges&quot;) [ {&quot;vwoRFklWfHJe1Fqjv7wY6exTyh23PjIBC4tTc4meXCeZQFEMwYorp3uYToGo8rVwxoU7c+C8eFuFOuF+unJQ8g==&quot;, %{ -3 =&gt; &lt;&lt;121, 21, 84, 106, 84, 48, 91, 21, 161, 78, 176, 199, 224, 86, 196, 226, 116, 207, 221, 200, 26, 202, 214, 78, 95, 112, 140, 236, 190, 183, 177, 223&gt;&gt;, -2 =&gt; &lt;&lt;195, 105, 55, 252, 13, 134, 94, 208, 83, 115, 8, 235, 190, 173, 107, 78, 247, 125, 65, 216, 252, 232, 41, 13, 39, 104, 231, 65, 200, 149, 172, 118&gt;&gt;, -1 =&gt; 1, 1 =&gt; 2, 3 =&gt; -7 }}, {&quot;E0YtUWEPcRLyW1wd4v3KuHqlW1DRQmF2VgNhhR1FumtMYPUEu/d3RO+WC4T4XIa0PZ6Pjw+IBNQDn/It5UjWmw==&quot;, %{ -3 =&gt; &lt;&lt;113, 34, 76, 107, 120, 21, 246, 189, 21, 167, 119, 39, 245, 140, 143, 133, 209, 19, 63, 196, 145, 52, 43, 2, 193, 208, 200, 103, 3, 51, 37, 123&gt;&gt;, -2 =&gt; &lt;&lt;199, 68, 146, 57, 216, 62, 11, 98, 8, 108, 9, 229, 40, 97, 201, 127, 47, 240, 50, 126, 138, 205, 37, 148, 172, 240, 65, 125, 70, 81, 213, 152&gt;&gt;, -1 =&gt; 1, 1 =&gt; 2, 3 =&gt; -7 }} ] iex&gt; Wax.new_authentication_challenge(cred_ids_and_associated_keys, []) %Wax.Challenge{ allow_credentials: [ {&quot;vwoRFklWfHJe1Fqjv7wY6exTyh23PjIBC4tTc4meXCeZQFEMwYorp3uYToGo8rVwxoU7c+C8eFuFOuF+unJQ8g==&quot;, %{ -3 =&gt; &lt;&lt;121, 21, 84, 106, 84, 48, 91, 21, 161, 78, 176, 199, 224, 86, 196, 226, 116, 207, 221, 200, 26, 202, 214, 78, 95, 112, 140, 236, 190, 183, 177, 223&gt;&gt;, -2 =&gt; &lt;&lt;195, 105, 55, 252, 13, 134, 94, 208, 83, 115, 8, 235, 190, 173, 107, 78, 247, 125, 65, 216, 252, 232, 41, 13, 39, 104, 231, 65, 200, 149, 172, 118&gt;&gt;, -1 =&gt; 1, 1 =&gt; 2, 3 =&gt; -7 }}, {&quot;E0YtUWEPcRLyW1wd4v3KuHqlW1DRQmF2VgNhhR1FumtMYPUEu/d3RO+WC4T4XIa0PZ6Pjw+IBNQDn/It5UjWmw==&quot;, %{ -3 =&gt; &lt;&lt;113, 34, 76, 107, 120, 21, 246, 189, 21, 167, 119, 39, 245, 140, 143, 133, 209, 19, 63, 196, 145, 52, 43, 2, 193, 208, 200, 103, 3, 51, 37, 123&gt;&gt;, -2 =&gt; &lt;&lt;199, 68, 146, 57, 216, 62, 11, 98, 8, 108, 9, 229, 40, 97, 201, 127, 47, 240, 50, 126, 138, 205, 37, 148, 172, 240, 65, 125, 70, 81, 213, 152&gt;&gt;, -1 =&gt; 1, 1 =&gt; 2, 3 =&gt; -7 }} ], bytes: &lt;&lt;130, 70, 153, 38, 189, 145, 193, 3, 132, 158, 170, 216, 8, 93, 221, 46, 206, 156, 104, 24, 78, 167, 182, 5, 6, 128, 194, 201, 196, 246, 243, 194&gt;&gt;, exp: nil, origin: &quot;http://localhost:4000&quot;, rp_id: &quot;localhost&quot;, token_binding_status: nil, trusted_attestation_types: [:none, :basic, :uncertain, :attca, :self], user_verification: &quot;preferred&quot;, verify_trust_root: true }","ref":"Wax.html#new_authentication_challenge/2","title":"Wax.new_authentication_challenge/2","type":"function"},{"doc":"Generates a new challenge for registrationThe returned structure:Contains the challenge bytes under the bytes key (e.g.: challenge.bytes). This is a random value that must be used by the javascript WebAuthn callMust be passed backed to register/3Typically, this structure is stored in the session (cookie...) for the time the WebAuthn process is performed on the client side.Example:iex&gt; Wax.new_registration_challenge(trusted_attestation_types: [:basic, :attca]) %Wax.Challenge{ allow_credentials: [], bytes: &lt;&lt;192, 64, 240, 166, 163, 188, 76, 255, 108, 227, 18, 33, 123, 19, 61, 3, 166, 195, 190, 157, 24, 207, 210, 179, 180, 136, 10, 135, 82, 172, 134, 17&gt;&gt;, origin: &quot;http://localhost:4000&quot;, rp_id: &quot;localhost&quot;, token_binding_status: nil, trusted_attestation_types: [:basic, :attca], user_verification: &quot;preferred&quot;, verify_trust_root: true }","ref":"Wax.html#new_registration_challenge/1","title":"Wax.new_registration_challenge/1","type":"function"},{"doc":"Verifies a registration response from the client WebAuthn javascript callThe input params are:attestation_object_cbor: the raw binary response from the WebAuthn javascript API. When transmitting it back from the browser to the server, it will probably be base64 encoded. Make sure to decode it before.client_data_json_raw: the JSON string (and not the decoded JSON) of the client data JSON as returned by the WebAuthn javascript APIchallenge: the challenge that was generated beforehand, and whose bytes has been sent to the browser and used as an input by the WebAuthn javascript APIThe success return value is of the form: {authenticator_data, {attestation_type, trust_path, metadata_statement}}. One can access the credential public key i nthe authenticator data structure:auth_data.attested_credential_data.credential_public_keyRegarding the attestation processes' result, see Wax.Attestation.result/0 for more details. Note, however, that you can use the returned metadata statement (if any) to further check the authenticator capabilites. For example, the following conditions will only allow attestation generated by hardware protected attestation keys:case Wax.register(attestation_object, client_data_json_raw, challenge) do {:ok, {authenticator_data, {_, _, metadata_statement}}} -&gt; # tee is for &quot;trusted execution platform&quot; if :key_protection_tee in metadata_statement.key_protection or :key_protection_secure_element in metadata_statement.key_protection do register_key(user, credential_id, authenticator_data.attested_credential_data.cose_key) :ok else {:error, :not_hardware_protected} end {:error, _} = error -&gt; error endWhen performing registration, the server has the 3 following pieces of data:user id: specific to the server implementation. Can be a email, login name, or an opaque user identifiercredential id: an ID returned by the WebAuthn javascript. It is a handle to further authenticate the user. It is also available in the authenticator data in binary form, and can be accessed by typing: auth_data.attested_credential_data.credential_idthe COSE key: available in the authenticator data (auth_data.attested_credential_data.credential_public_key) under the form of a map containing a public key use for further authenticationA credential id is related to a cose key, and vice-versa.Note that a user can have several (credential id, cose key) pairs, for example if the user uses different authenticators. The unique key (for storage, etc.) is therefore the tuple (user id, credential id).In the success case, and after calling register/3, a server shall:Verify that no other user has the same credential id (and should fail otherwise)Store the new tuple (credential id, cose key) for the user","ref":"Wax.html#register/3","title":"Wax.register/3","type":"function"},{"doc":"","ref":"Wax.html#t:opt/0","title":"Wax.opt/0","type":"type"},{"doc":"","ref":"Wax.html#t:opts/0","title":"Wax.opts/0","type":"type"},{"doc":"","ref":"Wax.Attestation.html","title":"Wax.Attestation","type":"module"},{"doc":"","ref":"Wax.Attestation.html#t:attestation_statement_format_verify_fun/0","title":"Wax.Attestation.attestation_statement_format_verify_fun/0","type":"type"},{"doc":"","ref":"Wax.Attestation.html#t:result/0","title":"Wax.Attestation.result/0","type":"type"},{"doc":"The attestation statement","ref":"Wax.Attestation.html#t:statement/0","title":"Wax.Attestation.statement/0","type":"type"},{"doc":"The attestation path","ref":"Wax.Attestation.html#t:trust_path/0","title":"Wax.Attestation.trust_path/0","type":"type"},{"doc":"The attestation type","ref":"Wax.Attestation.html#t:type/0","title":"Wax.Attestation.type/0","type":"type"},{"doc":"","ref":"Wax.AttestationStatementFormat.html","title":"Wax.AttestationStatementFormat","type":"behaviour"},{"doc":"","ref":"Wax.AttestationStatementFormat.html#c:verify/4","title":"Wax.AttestationStatementFormat.verify/4","type":"callback"},{"doc":"The attestation statement format","ref":"Wax.AttestationStatementFormat.html#t:statement_format/0","title":"Wax.AttestationStatementFormat.statement_format/0","type":"type"},{"doc":"","ref":"Wax.AttestedCredentialData.html","title":"Wax.AttestedCredentialData","type":"module"},{"doc":"","ref":"Wax.AttestedCredentialData.html#t:t/0","title":"Wax.AttestedCredentialData.t/0","type":"type"},{"doc":"","ref":"Wax.AuthenticatorData.html","title":"Wax.AuthenticatorData","type":"module"},{"doc":"","ref":"Wax.AuthenticatorData.html#decode/1","title":"Wax.AuthenticatorData.decode/1","type":"function"},{"doc":"","ref":"Wax.AuthenticatorData.html#t:credential_id/0","title":"Wax.AuthenticatorData.credential_id/0","type":"type"},{"doc":"","ref":"Wax.AuthenticatorData.html#t:t/0","title":"Wax.AuthenticatorData.t/0","type":"type"},{"doc":"","ref":"Wax.Challenge.html","title":"Wax.Challenge","type":"module"},{"doc":"","ref":"Wax.Challenge.html#t:t/0","title":"Wax.Challenge.t/0","type":"type"},{"doc":"","ref":"Wax.ClientData.html","title":"Wax.ClientData","type":"module"},{"doc":"","ref":"Wax.ClientData.html#t:hash/0","title":"Wax.ClientData.hash/0","type":"type"},{"doc":"The raw string as returned by the javascript WebAuthn APIExample: {&quot;challenge&quot;:&quot;aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaY&quot;,&quot;clientExtensions&quot;:{},&quot;hashAlgorithm&quot;:&quot;SHA-256&quot;,&quot;origin&quot;:&quot;http://localhost:4000&quot;,&quot;type&quot;:&quot;webauthn.create&quot;}","ref":"Wax.ClientData.html#t:raw_string/0","title":"Wax.ClientData.raw_string/0","type":"type"},{"doc":"","ref":"Wax.ClientData.html#t:t/0","title":"Wax.ClientData.t/0","type":"type"},{"doc":"","ref":"Wax.ClientData.TokenBinding.html","title":"Wax.ClientData.TokenBinding","type":"module"},{"doc":"","ref":"Wax.ClientData.TokenBinding.html#t:t/0","title":"Wax.ClientData.TokenBinding.t/0","type":"type"},{"doc":"","ref":"Wax.CoseKey.html","title":"Wax.CoseKey","type":"module"},{"doc":"Returns the list of supported algorithmsiex&gt; Wax.CoseKey.supported_algs() %{ -65535 =&gt; &quot;RSASSA-PKCS1-v1_5 w/ SHA-1&quot;, -259 =&gt; &quot;RS512 (TEMPORARY - registered 2018-04-19, expires 2019-04-19)&quot;, -258 =&gt; &quot;RS384 (TEMPORARY - registered 2018-04-19, expires 2019-04-19)&quot;, -257 =&gt; &quot;RS256 (TEMPORARY - registered 2018-04-19, expires 2019-04-19)&quot;, -42 =&gt; &quot;RSAES-OAEP w/ SHA-512&quot;, -41 =&gt; &quot;RSAES-OAEP w/ SHA-256&quot;, -39 =&gt; &quot;PS512&quot;, -38 =&gt; &quot;PS384&quot;, -37 =&gt; &quot;PS256&quot;, -36 =&gt; &quot;ES512&quot;, -35 =&gt; &quot;ES384&quot;, -7 =&gt; &quot;ES256&quot; }","ref":"Wax.CoseKey.html#supported_algs/0","title":"Wax.CoseKey.supported_algs/0","type":"function"},{"doc":"Verifies the signature of a message against a COSE keyUse supported_algs/0 to determine supported algorithms.","ref":"Wax.CoseKey.html#verify/3","title":"Wax.CoseKey.verify/3","type":"function"},{"doc":"","ref":"Wax.CoseKey.html#t:cose_alg/0","title":"Wax.CoseKey.cose_alg/0","type":"type"},{"doc":"","ref":"Wax.CoseKey.html#t:t/0","title":"Wax.CoseKey.t/0","type":"type"},{"doc":"","ref":"Wax.CredentialId.html","title":"Wax.CredentialId","type":"module"},{"doc":"The binary representation of a credential idIt is usually transmitted to a FIDO2 RP encoded as a base 64 string. One can decode it as follows:Base.url_decode64!(credential_id, padding: false)or keep it and store it with its base64 format","ref":"Wax.CredentialId.html#t:t/0","title":"Wax.CredentialId.t/0","type":"type"},{"doc":"Structure representing a FIDO2 metadata statementReference: FIDO Metadata StatementsNote that the following keys are not included in this module because of irrelevance:legalHeaderalternativeDescriptionstcDisplayPNGCharacteristicsicontc_display_content_type","ref":"Wax.Metadata.Statement.html","title":"Wax.Metadata.Statement","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.html#from_json!/1","title":"Wax.Metadata.Statement.from_json!/1","type":"function"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:attachment_hint/0","title":"Wax.Metadata.Statement.attachment_hint/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:attestation_type/0","title":"Wax.Metadata.Statement.attestation_type/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:authentication_algorithm/0","title":"Wax.Metadata.Statement.authentication_algorithm/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:key_protection/0","title":"Wax.Metadata.Statement.key_protection/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:matcher_protection/0","title":"Wax.Metadata.Statement.matcher_protection/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:public_key_representation_format/0","title":"Wax.Metadata.Statement.public_key_representation_format/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:t/0","title":"Wax.Metadata.Statement.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:tc_display/0","title":"Wax.Metadata.Statement.tc_display/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:user_verification_method/0","title":"Wax.Metadata.Statement.user_verification_method/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.html#t:verification_method_and_combinations/0","title":"Wax.Metadata.Statement.verification_method_and_combinations/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.EcdaaTrustAnchor.html","title":"Wax.Metadata.Statement.EcdaaTrustAnchor","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.EcdaaTrustAnchor.html#t:t/0","title":"Wax.Metadata.Statement.EcdaaTrustAnchor.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.ExtensionDescriptor.html","title":"Wax.Metadata.Statement.ExtensionDescriptor","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.ExtensionDescriptor.html#t:t/0","title":"Wax.Metadata.Statement.ExtensionDescriptor.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.UPV.html","title":"Wax.Metadata.Statement.UPV","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.UPV.html#t:t/0","title":"Wax.Metadata.Statement.UPV.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.html","title":"Wax.Metadata.Statement.VerificationMethodDescriptor","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.html#t:t/0","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.BiometricAccuracyDescriptor.html","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.BiometricAccuracyDescriptor","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.BiometricAccuracyDescriptor.html#t:t/0","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.BiometricAccuracyDescriptor.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.CodeAccuracyDescriptor.html","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.CodeAccuracyDescriptor","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.CodeAccuracyDescriptor.html#t:t/0","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.CodeAccuracyDescriptor.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.PatternAccuracyDescriptor.html","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.PatternAccuracyDescriptor","type":"module"},{"doc":"","ref":"Wax.Metadata.Statement.VerificationMethodDescriptor.PatternAccuracyDescriptor.html#t:t/0","title":"Wax.Metadata.Statement.VerificationMethodDescriptor.PatternAccuracyDescriptor.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.TOCEntry.html","title":"Wax.Metadata.TOCEntry","type":"module"},{"doc":"","ref":"Wax.Metadata.TOCEntry.html#t:t/0","title":"Wax.Metadata.TOCEntry.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.TOCEntry.BiometricStatusReport.html","title":"Wax.Metadata.TOCEntry.BiometricStatusReport","type":"module"},{"doc":"","ref":"Wax.Metadata.TOCEntry.BiometricStatusReport.html#t:t/0","title":"Wax.Metadata.TOCEntry.BiometricStatusReport.t/0","type":"type"},{"doc":"","ref":"Wax.Metadata.TOCEntry.StatusReport.html","title":"Wax.Metadata.TOCEntry.StatusReport","type":"module"},{"doc":"","ref":"Wax.Metadata.TOCEntry.StatusReport.html#t:status/0","title":"Wax.Metadata.TOCEntry.StatusReport.status/0","type":"type"},{"doc":"","ref":"Wax.Metadata.TOCEntry.StatusReport.html#t:t/0","title":"Wax.Metadata.TOCEntry.StatusReport.t/0","type":"type"},{"doc":"WaxWebAuthn library for elixirGoal: implement a comprehensive FIDO2 library on the server side (Relying party or RP in the WebAuthn terminology) to authenticate users with WebAuthn.For semantics (FIDO2, WebAuthn, FIDO...), read this article","ref":"readme.html","title":"Wax","type":"extras"},{"doc":"You can try out and study WebAuthn authentication with Wax thanks to the wax_demo test application.See also a video demonstration of an authentication flow which allows replacing the password authentication scheme by a WebAuthn password-less authentication:","ref":"readme.html#demo-app","title":"Wax - Demo app","type":"extras"},{"doc":"Support the FIDO2 standard (especially all types of attestation statement formats and all mandatory algorithms). See the &quot;Support of FIDO2&quot; section for further informationPasses all the 165 tests of the official test suite (tested using WaxFidoTestSuiteServer)This library has not be reviewed by independent security / FIDO2 specialists - use it at your own risks or blindly trust its author!This library does not come with a javascript library to handle WebAuthn calls","ref":"readme.html#project-status","title":"Wax - Project status","type":"extras"},{"doc":"OTP22+","ref":"readme.html#compatibility","title":"Wax - Compatibility","type":"extras"},{"doc":"Add the following line to your list of dependencies in mix.exs:def deps do [ {:wax_, &quot;~&gt; 0.4.0&quot;} ] endNote that due to a name collision, the application name is :wax_, and not :wax. It doesn't cause issues using both library because the other's package doesn't use the atom Wax as the base module name.Documentation","ref":"readme.html#installation","title":"Wax - Installation","type":"extras"},{"doc":"To use FIDO2 for authentication, you must first register a new FIDO2 key for a user. The process is therefore the following:Register a FIDO2 key for a userAuthenticate as much as you want the user using the FIDO2 key registered in step 1Optionaly, you might want to store more than one key, for instance if the user have several authenticators.The Wax library doesn't provide with a user data store to store the key generated in step 1 and to retrieve it in step 2. Instead, it lets you use any data store. The data to be stored is described in the Wax module's documentation.RegistrationWax provides with 2 functions for registration:Wax.new_registration_challenge/1: generates a challenge that must subsequently be sent to the client for use by the javascript WebAuthn APIWax.register/3: takes into parameter the response of the WebAuthn javascript API and the challenge generated in step 1, and verifies itSince the challenge generated in step 1 must be passed as a parameter in step 2, it is required to persist it on the server side, for instance in the session:# generating a challenge challenge = Wax.new_registration_challenge(login, []) conn |&gt; put_session(:challenge, challenge) |&gt; render(register_key_page, challenge: challenge.bytes) # the challenge is to be sent on the client one way or another # this can be direct within the HTML, or using an API callto be then retrieved when verifying the assertion:challenge = get_session(conn, :challenge) case Wax.register(attestation_object, client_data_json, challenge) do {:ok, {key, _}} -&gt; # success case {:error, _} -&gt; # verification failure endIn the success case, a server will save the credential id (generated by the WebAuthn javascript call) and the cose key in its user database for use for authentication.The key is a map that looks like:%{ -3 =&gt; &lt;&lt;182, 81, 183, 218, 92, 107, 106, 120, 60, 51, 75, 104, 141, 130, 119, 232, 34, 245, 84, 203, 246, 165, 148, 179, 169, 31, 205, 126, 241, 188, 241, 176&gt;&gt;, -2 =&gt; &lt;&lt;89, 29, 193, 225, 4, 234, 101, 162, 32, 6, 15, 14, 130, 179, 223, 207, 53, 2, 134, 184, 178, 127, 51, 145, 57, 180, 104, 242, 138, 96, 27, 221&gt;&gt;, -1 =&gt; 1, 1 =&gt; 2, 3 =&gt; -7 }It probably doesn't need to be searchable or indexed, which is why one can store as a binary. To convert back and forth Elixir data structures to binary and store the keys in a database (SQL, for instance), take a look at the Erlang functions term_to_binary/1 and binary_to_term/1.For further information, refer to the Wax module documentation.AuthenticationThe process is quite similar, with 2 functions for authentication:Wax.new_authentication_challenge/2: generates a challenge from a list of (credential id, key) saved during the registration processes. It also has to be sent to the client for use by the javascript WebAuthn APIWax.authenticate/5: to be called to verify the WebAuthn javascript API response with the returned data (composed of signature, authenticator data, etc.) with the challenge generated in step 1This also requires storing the challenge:cred_ids_and_keys = UserStore.get_keys(username) challenge = Wax.new_authentication_challenge(cred_ids_and_keys, []) conn |&gt; put_session(:authentication_challenge, challenge) |&gt; render(auth_verify_page, challenge: challenge.bytes, creds: cred_ids_and_keys) # the challenge is to be sent on the client one way or another # this can be direct within the HTML, or using an API callto be passed as a paramter to the Wax.authenticate/5 function:challenge = get_session(conn, :authentication_challenge) case Wax.authenticate(raw_id, authenticator_data, sig, client_data_json, challenge) do {:ok, _} -&gt; # ok, user authenticated {:error, _} -&gt; # invalid WebAuthn response endFor further information, refer to the Wax module documentation.","ref":"readme.html#usage","title":"Wax - Usage","type":"extras"},{"doc":"The options are set when generating the challenge (for both registration and authentication). Options can be configured either globally in the configuration file or when generating the challenge. Some also have default values.Option values set during challenge generation take precedence over globally configured options, which takes precedence over default values.These options are:OptionTypeApplies toDefault valueNotesattestation&quot;none&quot; or &quot;direct&quot;&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;&quot;none&quot;originString.t()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;Mandatory. Example: https://www.example.comrp_idString.t() or :auto&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;If set to :auto, automatically determined from the origin (set to the host)With :auto, it defaults to the full host (e.g.: www.example.com). This option allow you to set the rp_id to another valid value (e.g.: example.com)user_verification&quot;discouraged&quot;, &quot;preferred&quot; or &quot;required&quot;&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;&quot;preferred&quot;trusted_attestation_types[Wax.Attestation.type()]&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;[:none, :basic, :uncertain, :attca, :self]verify_trust_rootboolean()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;trueOnly for u2f and packed attestation. tpm attestation format is always checked against metadataacceptable_authenticator_statuses[Wax.Metadata.TOCEntry.StatusReport.status()]&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;[:fido_certified, :fido_certified_l1, :fido_certified_l1plus, :fido_certified_l2, :fido_certified_l2plus, :fido_certified_l3, :fido_certified_l3plus]The :update_available status is not whitelisted by defaulttimeoutnon_neg_integer()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;20 * 60The validity duration of a challengeandroid_key_allow_software_enforcementboolean()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;registration&lt;/li&gt;&lt;/ul&gt;falseWhen registration is a Android key, determines whether software enforcement is acceptable (true) or only hardware enforcement is (false)silent_authentication_enabledboolean()&lt;ul style=&quot;margin:0&quot;&gt;&lt;li&gt;authentication&lt;/li&gt;&lt;/ul&gt;falseSee https://github.com/fido-alliance/conformance-tools-issues/issues/434","ref":"readme.html#options","title":"Wax - Options","type":"extras"},{"doc":"Configuring the access tokenThe FIDO Alliance provides with a list of metadata statements of certified FIDO2 authenticators. A metadata statement contains trust anchors (root certificates) to verify attestations. Wax can automatically keep this metadata up to date but needs a access token which is provided by the FIDO Alliance. One can request it here: https://mds2.fidoalliance.org/tokens/.Once the token has been granted, it has to be added in the configuration file (consider adding it to your *.secret.exs files) with the :metadata_access_token key. The update frquency can be configured with the :metadata_update_interval key (in seconds, defaults to 12 hours). Example:config/dev.exs:use Mix.Config config :wax_, metadata_update_interval: 3600,config/dev.secret.exs:use Mix.Config config :wax_, metadata_access_token: &quot;d4904acd10a36f62d7a7d33e4c9a86628a2b0eea0c3b1a6c&quot;Note that some FIDO1 certififed authenticators, such as Yubikeys, won't be present in this list and Wax doesn't load data from the former (&quot;FIDO1&quot;) metadata Web Service. The FIDO Alliance plans to provides with a web service having both FIDO1 and FIDO2, but there is no roadmap as of September 2019.During the registration process, when trust root is verified against FIDO2 metadata, only metadata entries whose last status is whitelisted by the :acceptable_authenticator_statuses will be used. Otherwise a warning is logged and the registration process fails. Metadata is still loaded for debugging purpose in the :wax_metadata ETS table.Configuring the HTTP adapterWax uses Tesla to retrieve metadata and certificate revocation lists.Since Tesla's default adapter is :httpc, which performs insecure HTTPS request, it is highly recommended to configure another secure adapter. For instance, if you're are already using Hackney in your project (type mix deps.tree to determine which HTTP libraries are already used), then configure Tesla the following way:config/config.exsconfig :tesla, adapter: Tesla.Adapter.HackneySee Tesla's documentation for more information.","ref":"readme.html#fido2-metadata-service-mds-configuration","title":"Wax - FIDO2 Metadata service (MDS) configuration","type":"extras"},{"doc":"In addition to the FIDO2 metadata service, it is possible to load metadata from a directory. To do so, the :metadata_dir application environment variable must be set to one of:a String.t(): the path to the directory containing the metadata filesan atom(): in this case, the files are loaded from the &quot;fido2_metadata&quot; directory of the private (&quot;priv/&quot;) directory of the application (whose name is the atom)In both case, Wax tries to load all files (even directories and other special files).Example configurationconfig :wax_, origin: &quot;http://localhost:4000&quot;, rp_id: :auto, metadata_dir: :my_applicationwill try to load all files of the &quot;priv/fido2_metadata/&quot; of the :my_application as FIDO2 metadata statements. On failure, a warning is emitted.","ref":"readme.html#loading-fido2-metadata-from-a-directory","title":"Wax - Loading FIDO2 metadata from a directory","type":"extras"},{"doc":"Make sure to understand the implications of not using attested credentials before accepting none or self attestation types, or disabling it for packed and u2f formats by disabling it with the verify_trust_root optionThis library has not be reviewed by independent security / FIDO2 specialists - use it at your own risks or blindly trust its author! If you're knowledgeable about FIDO2 and willing to help reviewing it, please contact the author","ref":"readme.html#security-considerations","title":"Wax - Security considerations","type":"extras"},{"doc":"See CHANGELOG.md.","ref":"readme.html#changes","title":"Wax - Changes","type":"extras"},{"doc":"Server Requirements and Transport Binding Profile2. Registration and Attestations[x] Mandatory: registration support[x] Mandatory: random challenge2.1. Validating Attestation[x] Mandatory: attestation validation[x] Mandatory: attestation certificate chains (note: can be disabled through an option)[x] Mandatory: validation of attestation through the FIDO Metadata Service 2.2. Attestation Types[x] Mandatory: basic attestation[x] Mandatory: self attestation[x] Mandatory: private CA attestation[ ] Optional: elliptic curve direct anonymous attestation2.3. Attestation Formats[x] Mandatory: packed attestation[x] Mandatory: TPM attestation[x] Optional: Android key attestation[x] Mandatory: U2F attestation[x] Mandatory: Android Safetynet attestation3. Authentication and Assertions[x] Mandatory: authentication[x] Mandatory: random challenge[x] Mandatory: assertion signature validation[x] Mandatory: TUP verification (note: and also user verified, through an option)4. Communication Channel Requirements[ ] Optional: TokenBinding support (won't be supported following Chrome drop of the now dead token binding standard)5. Extensions[x] Mandatory: registration and authentication support without extension[ ] Optional: extension support[ ] Optional: appid extension support6. Other[x] Mandatory: RS1 (RSASSA-PKCS1-v1_5 w/ SHA-1) algorithm support[x] Mandatory: RS256 (RSASSA-PKCS1-v1_5 w/ SHA-256) algorithm support[x] Optional: RS384 (RSASSA-PKCS1-v1_5 w/ SHA-384) algorithm support[x] Optional: RS512 (RSASSA-PKCS1-v1_5 w/ SHA-512) algorithm support[x] Optional: PS256 (RSASSA-PSS w/ SHA-256) algorithm support[x] Optional: PS384 (RSASSA-PSS w/ SHA-384) algorithm support[x] Optional: PS512 (RSASSA-PSS w/ SHA-512) algorithm support[x] Mandatory: ES256 (ECDSA using P-256 and SHA-256) algorithm support[x] Optional: ES384 (ECDSA using P-384 and SHA-384) algorithm support[x] Optional: ES512 (ECDSA using P-521 and SHA-512) algorithm support[x] Optional: EdDSA algorithm support[x] Optional: ES256K (ECDSA using P-256K and SHA-256) algorithm support[ ] Mandatory: compliance with the FIDO privacy principles (note: out-of-scope, to be implemented by the server using the Wax library)7. Transport Binding Profile[x] optional: API implementation (WaxAPIRest)FIDO Metadata Service3.1.8 Metadata TOC object processing rules[ ] TOC verification against the x5u attribute (note: doesn't seem to be used)[x] TOC verification against the x5c attribute[x] TOC CRLs verification[x] Loading and verification of metadata statements against the hased value of the TOC[x] Handling of the status of the authenticator (through whitelisting, see the :acceptable_authenticator_statuses option)","ref":"readme.html#support-of-fido2","title":"Wax - Support of FIDO2","type":"extras"},{"doc":"CHANGELOGAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Fixed[Wax.Metadata] Update root certificate for TOC integrity checking following FIDO MDSv2 switch to public PKI infrastructure","ref":"changelog.html#0-4-1-2021-05-18","title":"CHANGELOG - [0.4.1] - 2021-05-18","type":"extras"},{"doc":"Changed[Wax.Metadata] Metadata retrieval now makes use of the Tesla library. Beware, Tesla's default adapter is insecure (:https), so you need to configure a secure adapter, such as Hackney, if you use MDSv2 metadata.","ref":"changelog.html#0-4-0-2020-09-26","title":"CHANGELOG - [0.4.0] - 2020-09-26","type":"extras"},{"doc":"Fixed[Wax.Metadata.Statement] Added newly added user verification methods and attachment hints. User verification method names have been updated to reflect the latest specification. See Wax.Metadata.Statement.user_verification_method/0 type for new values.","ref":"changelog.html#0-3-1-2020-09-21","title":"CHANGELOG - [0.3.1] - 2020-09-21","type":"extras"},{"doc":"Changed[Wax] Renamed application to :wax_ due to a name collision. Do not forget to rename any :wax entry in your configuration files[Wax] secp256k1's COSE alg value set to new standardized value","ref":"changelog.html#0-3-0-2020-09-18","title":"CHANGELOG - [0.3.0] - 2020-09-18","type":"extras"},{"doc":"Fixed[Wax.AttestationStatementFormat.TPM] Commented TPM manufacturer ID used only for testing with the FIDO2 test suite","ref":"changelog.html#0-2-1-2020-05-30","title":"CHANGELOG - [0.2.1] - 2020-05-30","type":"extras"},{"doc":"Added[Wax] When verifying trust root, Wax.register/3 checks the authenticator status against the values whitelisted by the :acceptable_authenticator_statuses option[Wax.CoseKey] Added support for PS256, PS384, PS512, EdDSA signature schemes and ES256K (secp256k1 curve) signature algorithms[Wax.Challenge] Added timeout field and verification[Wax] Added :android_key_allow_software_enforcement option[Wax.Metadata] FIDO2 metadata TOC checked against CRLs (#12)[Wax] Added a mean to load metadata from a directory[Wax] Added :silent_authentication_enabled optionChanged[Wax] Wax.register/3 and Wax.authenticate/5 signatures change and now return the whole authenticator data.[Wax] the :user_verified_required option is replace by the :user_verification optionFixed[Wax.Metadata] TOC JWS signature is verified against FIDO Fundation certificate","ref":"changelog.html#0-2-0-2020-04-17","title":"CHANGELOG - [0.2.0] - 2020-04-17","type":"extras"}]